config/routes.rb
Rails.application.routes.draw do
  resources :quotations do
    member do
      delete 'destroy'  # Use DELETE for destroy action
      get 'edit'
      patch 'update'
    end
  end
 
  get 'problemset1', to: 'problemset1#subpage'
  get 'q1', to: 'q1#show'
  get 'q3', to: 'news#index'

  get 'q2', to: 'q2#index'
  # Define your application routes per the DSL in https://guides.rubyonrails.org/routing.html
  root 'main_site#index'

  get 'problemset2', to: 'problemset2#subpage'
  get 'quotations', to: 'quotations#quotations'

  
  # Defines the root path route ("/")
  # root "articles#index"
end

app/models/application_record.rb
class ApplicationRecord < ActiveRecord::Base
  primary_abstract_class
end

app/models/quotation.rb
class Quotation < ApplicationRecord
end

app/controllers/application_controller.rb
class ApplicationController < ActionController::Base
end

app/controllers/main_site_controller.rb
class MainSiteController < ApplicationController

end

app/controllers/news_controller.rb
class NewsController < ApplicationController
    require 'nokogiri'
    require 'httparty'
  
    def index
      @nyt_headlines = fetch_nyt_headlines
      @bangkok_post_headlines = fetch_bangkok_post_headlines
    end
  
    private
  
    def fetch_nyt_headlines
      nyt_url = 'https://www.nytimes.com'
      response = HTTParty.get(nyt_url)
      doc = Nokogiri::HTML(response.body)
  
      # Find all links containing "/world/" in the URL
      links = doc.css('a').select { |link| link['href']&.include?('/world/') }
  
      headlines = links.map do |link|
        {
          text: link.text,
          href: URI.join(nyt_url, link['href']).to_s
        }
      end
  
      headlines
    end
  
    def fetch_bangkok_post_headlines
      bangkok_post_url = 'https://www.bangkokpost.com'
      response = HTTParty.get(bangkok_post_url)
      doc = Nokogiri::HTML(response.body)
  
      # Find all links containing "/thailand/" in the URL
      links = doc.css('a').select { |link| link['href']&.include?('/thailand/') }
  
      headlines = links.map do |link|
        {
          text: link.text,
          href: URI.join(bangkok_post_url, link['href']).to_s
        }
      end
  
      headlines
    end
  end

  

app/controllers/problemset1_controller.rb
class Problemset1Controller < ApplicationController
    def subpage
    end
  end
  

app/controllers/problemset2_controller.rb
class Problemset2Controller < ApplicationController
    def subpage
    end
  end
  

app/controllers/q1_controller.rb
class Q1Controller < ApplicationController
    def show
    end
  end
  

app/controllers/q2_controller.rb
class Q2Controller < ApplicationController
    def index
      begin
        # Add code to log a message before dividing by zero
        Rails.logger.error("About to divide by 0")
        
        # Generate a divide-by-zero exception
        result = 5 / 0
  
        # The exception will prevent this code from running
      rescue StandardError => e
        # If an exception occurs, set an error message
        @error_message = "An error occurred: #{e.message}"
      end
    end
  end
  
  

app/controllers/quotations_controller.rb
class QuotationsController < ApplicationController
  def quotations
    if params[:quotation]
      @quotation = Quotation.new(params[:quotation])
      if @quotation.save
        flash[:notice] = 'Quotation was successfully created.'
        @quotation = Quotation.new
      end
    else
      @quotation = Quotation.new
    end
  
    if params[:sort_by] == "date"
      @quotations = Quotation.order(:created_at)
    else
      @quotations = Quotation.order(:category)
    end
  end

  def index
    if params[:query].present?
      @quotations = Quotation.where("LOWER(quote) LIKE ? OR LOWER(author_name) LIKE ?", "%#{params[:query].downcase}%", "%#{params[:query].downcase}%")
    else
      @quotations = Quotation.all
      respond_to do |format|
        format.html
        format.xml { render xml: @quotations }
        format.json { render json: @quotations }
      end
    end
  end

  def new
    @quotation = Quotation.new
    @existing_categories = Quotation.distinct.pluck(:category)
  end

  def create
    @quotation = Quotation.new(quotation_params)

    if @quotation.save
      flash[:notice] = 'Quotation was successfully created.'
      redirect_to quotations_path
    else
      @existing_categories = Quotation.distinct.pluck(:category)
      render :new
    end
  end

  def kill_quotation
    # Assume params[:id] contains the quotation ID to be killed
    killed_quotations = cookies[:killed_quotations].to_s.split(' ')
    killed_quotations << params[:id]
    cookies[:killed_quotations] = killed_quotations.uniq.join(' ')
  end
  
  # In your controller, erase personalization
  
  def erase_personalization
    cookies.delete(:killed_quotations)
  end

  def destroy
    @quotation = Quotation.find(params[:id])
    @quotation.destroy
    redirect_to quotations_path, notice: 'Quotation was successfully deleted.'
  end

  def edit
    @quotation = Quotation.find(params[:id])
  end

  def update
    @quotation = Quotation.find(params[:id])

    if @quotation.update(quotation_params)
      redirect_to quotations_path, notice: 'Quotation was successfully updated.'
    else
      render :edit
    end
  end

  private

  def quotation_params
    params.require(:quotation).permit(:author_name, :category, :quote)
  end
  
    
end

app/helpers/application_helper.rb
module ApplicationHelper
end

app/helpers/quotations_helper.rb
module QuotationsHelper
end

app/views/layouts/application.html.erb
<!DOCTYPE html>
<html>
  <head>
    <title>Myweb</title>
    <meta name="viewport" content="width=device-width,initial-scale=1">
    <%= csrf_meta_tags %>
    <%= csp_meta_tag %>

    <%= stylesheet_link_tag "application", "data-turbo-track": "reload" %>
    <%= javascript_importmap_tags %>
  </head>

  <body>
    
    <%= yield %>
    <%= render 'shared/validation_link' %>
  </body>
</html>

app/views/main_site/index.html.erb
<!DOCTYPE html>
<html>
<head>
  <title>Main Site</title>
</head>
<body>
  <h1>Welcome to the Main Site</h1>
  <ul>
    <li><a href="/problemset1">Problem Set 1</a></li>
    <li><a href="/problemset2">Problem Set 2</a></li>
    <!-- Add more links for other problem sets as needed -->
  </ul>
</body>
</html>

app/views/news/index.html.erb
<h1>New York Times Headlines</h1>
<ul>
  <% @nyt_headlines.each do |headline| %>
    <li><a href="<%= headline[:href] %>"><%= headline[:text] %></a></li>
  <% end %>
</ul>

<h1>Bangkok Post Headlines</h1>
<ul>
  <% @bangkok_post_headlines.each do |headline| %>
    <li><a href="<%= headline[:href] %>"><%= headline[:text] %></a></li>
  <% end %>
</ul>

app/views/problemset1/subpage.html.erb
<h1>Problemset1#subpage</h1>
<p>Find me in app/views/problemset1/subpage.html.erb</p>
<li><a href="/q1">Q1</a></li>
<li><a href="/q2">Q2</a></li>
<li><a href="/q3">Q3</a></li>

app/views/problemset2/subpage.html.erb
<h1>Problemset2#subpage</h1>
<p>Find me in app/views/problemset2/subpage.html.erb</p>
<li><a href="/quotations">Quotation</a></li>

app/views/q1/show.html.erb
<h1>Q1#show</h1>
<p>To add an XHTML syntax validation link to the bottom of your Ruby on Rails site's view layout, you can follow these steps:</p>

<h3> 1.Create a Partial for the Validation Link: </h3>
<p> First, you should create a partial that contains the XHTML validation link. This way, you can include it in your site's layout across all pages. Let's create a partial called _validation_link.html.erb in your app/views/shared folder: </p>
<pre>
        <code>
            &lt; !-- app/views/shared/_validation_link.html.erb -- &gt;
            &lt; %if Rails.env.development?% &gt;
                &lt;div style="text-align: center; margin-top: 20px;"&gt;
                    &lt;a href="https://validator.w3.org/check?uri=referer" target="_blank"&gt;
                        &lt;img src="https://www.w3.org/Icons/valid-xhtml10-blue" alt="Valid XHTML 1.0 Transitional" height="31" width="88" /&gt;
                    &lt;/a&gt;
                &lt;/div&gt;
            &lt;% end %&gt;
        </code>
    </pre>

    <p> In this code, we check if the Rails environment is set to development before displaying the validation link, as it's typically not necessary in production. </p>


<h3> 2.Include the Partial in Your Layout: </h3>
<p> Next, you'll include this partial in your site's layout. Typically, layouts are located in the app/views/layouts folder. Let's assume your layout file is named application.html.erb. Open it and add the following line where you want the validation link to appear, usually at the bottom of the page, inside the <body> tag: </p>

<pre>
        <code>
            &lt; !-- app/views/layouts/application.html.erb -- &gt;
            &lt; !DOCTYPE html &gt;
            &lt; html &gt;
            &lt; head &gt;
                &lt; !-- ... your head content ... -- &gt;
            &lt; /head &gt;
            &lt; body &gt;
                &lt; !-- ... your page content ... -- &gt;
                &lt; %= render 'shared/validation_link' % &gt;
            &lt;/body &gt;
            &lt;/html &gt;
        </code>
</pre>


<h3> 3.Testing: </h3>
<p> Save both the partial and the layout changes. Now, when you load any page in your Rails application in the development environment, you should see the XHTML validation link at the bottom of the pages. This link will take users to the W3C XHTML validation service for checking the validity of your page's markup. </p>

app/views/q2/index.html.erb
<h1>Q2:Error Occurred</h1>
<p>An error occurred while processing your request:</p>
<p><%= @error_message %></p>

<h4> Explaination </h4>
<p> In this code, we rescue the exception that occurs during the division and set an @error_message variable with the error message. </p>
<p> In my q2_controller, I have define the result = 5 / 0 
<p> -if the divider != 0, then the error message will not shown </p>
<p> -If my divider == 0, then the error message,An error occurred: divided by 0, will be appear</p>

app/views/quotations/_form.html.erb
<%= form_with(model: quotation) do |form| %>
  <% if quotation.errors.any? %>
    <div style="color: red">
      <h2><%= pluralize(quotation.errors.count, "error") %> prohibited this quotation from being saved:</h2>

      <ul>
        <% quotation.errors.each do |error| %>
          <li><%= error.full_message %></li>
        <% end %>
      </ul>
    </div>
  <% end %>

  <div>
    <%= form.label :author_name, style: "display: block" %>
    <%= form.text_field :author_name %>
  </div>

  <div>
    <%= form.label :category, style: "display: block" %>
    <%= form.text_field :category %>
  </div>

  <div>
    <%= form.label :quote, style: "display: block" %>
    <%= form.text_area :quote %>
  </div>

  <div>
    <%= form.submit %>
  </div>
<% end %>

app/views/quotations/_quotation.html.erb
<h3>Quotations</h3>
<ul>
  <% for quotation in @quotations %>
    <li><%= h quotation.author_name %>: <%= h quotation.quote %></li>
  <% end %>
</ul>
<br/>
<% if params[:sort_by] == "date" %>
  <%= link_to "Sort by category", :action => :quotations, :sort_by => :category %>
<% else %>
  <%= link_to "Sort by date", :action => :quotations, :sort_by => :date %>
<% end %>
<hr/>
<h3>New quotation</h3>
<%= form_for @quotation, :url => { :action => :quotations } do |form| %>
  <%= form.error_messages %>
  <fieldset>
    <legend>Enter details</legend>
    <div class="form_row">
      <%= form.label :author_name %>
      <%= form.text_field :author_name, :size => 20, :maxlength => 40 %>
    </div>
    <div class="form_row">
      <%= form.label :category %>
      <%= form.text_field :category, :size => 20, :maxlength => 40 %>
    </div>
    <div class="form_row">
      <%= form.label :quote %>
      <%= form.text_area :quote, :rows => 2, :cols => 40, :maxlength => 500 %>
    </div>
  </fieldset>
  <p>
    <div class="form_row">
      <%= form.submit 'Create' %>
    </div>
  </p>
<% end %>

app/views/quotations/edit.html.erb
<!-- app/views/quotations/edit.html.erb -->

<h3>Destroy successfully</h3>

<%= link_to 'Back', @quotation.destroy, method: :delete %>

app/views/quotations/index.html.erb
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="UTF-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>Quotations</title>
</head>
<body>

  <h1>Quotations</h1>

  <!-- Search Form -->
  <%= form_tag(quotations_path, method: 'get') do %>
    <%= text_field_tag(:query) %>
    <%= submit_tag("Search") %>
  <% end %>

  <!-- List of Quotations -->
  <ul>
    <% @quotations.each do |quotation| %>
      <li>
        <%= h quotation.author_name %> : <%= h quotation.category %> : <%= h quotation.quote %>
        <%= link_to 'Click for Destroy', edit_quotation_path(quotation), notice: 'Quotation was successfully deleted.' %>
      </li>
    <% end %>
  </ul>

  <!-- New Quotation Link -->
  <%= link_to 'New quotation', new_quotation_path %>



  <!-- Sort Links -->
  <br/>
  <% if params[:sort_by] == "date" %>
    <%= link_to "Sort by category", :action => :quotations, :sort_by => :category %>
  <% else %>
    <%= link_to "Sort by date", :action => :quotations, :sort_by => :date %>
  <% end %>

  <hr/>
  

</body>
</html>

app/views/quotations/new.html.erb
<h3>New Quotation</h3>
<%= form_with(model: @quotation, url: quotations_path) do |form| %>
  <%= form.label :author_name %>
  <%= form.text_field :author_name %>
  </br>
  <!-- <%= form.label :category %> -->
  <!-- <%= form.select :category, @existing_categories, prompt: 'Select existing category' %> -->
  <%= form.label :new_category, 'New category' %>
  <%= form.text_field :category %>

  <%= form.label :quote %>
  <%= form.text_area :quote %> 
  
  <%= form.submit 'Create' %>
 
  

<% end %>

<%= link_to 'Back', quotations_path %>

app/views/quotations/show.html.erb
<h2><%= @quotation.author_name %></h2>
<p><strong>Category:</strong> <%= @quotation.category %></p>
<p><strong>Quote:</strong> <%= @quotation.quote %></p>

<%= link_to 'Edit', edit_quotation_path(@quotation) %> |
<%= link_to 'Back', quotations_path %>

app/views/shared/_validation_link.html.erb
<!-- app/views/shared/_validation_link.html.erb -->
<% if Rails.env.development? %>
  <div style="text-align: center; margin-top: 20px;">
    <a href="https://validator.w3.org/check?uri=referer" target="_blank">
      <img src="https://www.w3.org/Icons/valid-xhtml10-blue" alt="Valid XHTML 1.0 Transitional" height="31" width="88" />
    </a>
  </div>
<% end %>